(function(){

var b91_enctab = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789!#$%&()*+,./:;<=>?@[]^_`{|}~"';

var b91_dectab = {'A':0, 'B':1, 'C':2, 'D':3, 'E':4, 'F':5, 'G':6, 'H':7, 'I':8, 'J':9, 'K':10, 'L':11, 'M':12,
                  'N':13, 'O':14, 'P':15, 'Q':16, 'R':17, 'S':18, 'T':19, 'U':20, 'V':21, 'W':22, 'X':23, 'Y':24, 'Z':25,
                  'a':26, 'b':27, 'c':28, 'd':29, 'e':30, 'f':31, 'g':32, 'h':33, 'i':34, 'j':35, 'k':36, 'l':37, 'm':38,
                  'n':39, 'o':40, 'p':41, 'q':42, 'r':43, 's':44, 't':45, 'u':46, 'v':47, 'w':48, 'x':49, 'y':50, 'z':51,
                  '0':52, '1':53, '2':54, '3':55, '4':56, '5':57, '6':58, '7':59, '8':60, '9':61, '!':62, '#':63, '$':64,
                  '%':65, '&':66, '(':67, ')':68, '*':69, '+':70, ',':71, '.':72, '/':73, ':':74, ';':75, '<':76, '=':77,
                  '>':78, '?':79, '@':80, '[':81, ']':82, '^':83, '_':84, '`':85, '{':86, '|':87, '}':88, '~':89, '"':90};


var base91_encode = function(d)
{
    var n = 0, q = 0;
    var s='', t;
    var i = 0;
    var buf = new Array(4);
    while (!isNaN(t = d.charCodeAt(i++))) {
	var l = 0;
	do{
	    buf[l++] = (t & 255);
	    t >>= 8;
	}while(t);
	for(var j = 0; j < l; j++){
	    q |= buf[j] << n;
	    n += 8;
	    if (n > 13) {
		var v = q & 8191;
		
		if (v > 88) {
		    q >>= 13;
		    n -= 13;
		} else {
		    v = q & 16383;
		    q >>= 14;
		    n -= 14;
		}
		s += b91_enctab.charAt(v % 91);
		s += b91_enctab.charAt(v / 91);
	    }
	}
    }
    if (n > 0) {
	s += b91_enctab.charAt(q % 91);
	if (n > 7 || q > 90)
	  s += b91_enctab.charAt(q / 91);
    }
    return s;
};

var base91_decode = function(d)
{
    var c;
    var v = -1;
    var s = '';
    var b = 0;
    var n = 0;
    var fcc = String.fromCharCode;
    var i = 0;
    while(!isNaN(c = b91_dectab[d.charAt(i++)])){
	if (v < 0)
	  v = c;
	else {
	    v += c * 91;
	    b |=  v << n;
	    n += (v & 8191) > 88 ? 13 : 14;
	    do {
		s += fcc(b & 255);
		b >>= 8;
		n -= 8;
	    } while (n > 7);
	    v = -1;
	}
    }
    if (v + 1)
      s += fcc((b | v << n) & 255);
    return s;
}

var re_char_nonascii = /[^\x00-\xFF]/g;

var sub_char_nonascii = function(m){
    var n = m.charCodeAt(0);
    return n < 0x800 ? String.fromCharCode(0xc0 | (n >>>  6))
                     + String.fromCharCode(0x80 | (n & 0x3f))
        :              String.fromCharCode(0xe0 | ((n >>> 12) & 0x0f))
                     + String.fromCharCode(0x80 | ((n >>>  6) & 0x3f))
                     + String.fromCharCode(0x80 |  (n         & 0x3f))
        ;
};

var utob = function(uni){
    return uni.replace(re_char_nonascii, sub_char_nonascii);
};
var re_bytes_nonascii
    = /[\xC0-\xDF][\x80-\xBF]|[\xE0-\xEF][\x80-\xBF]{2}|[\xF0-\xF7][\x80-\xBF]{3}/g;

var sub_bytes_nonascii = function(m){
    var c0 = m.charCodeAt(0);
    var c1 = m.charCodeAt(1);
    if(c0 < 0xe0){
        return String.fromCharCode(((c0 & 0x1f) << 6) | (c1 & 0x3f));
    }else{
        var c2 = m.charCodeAt(2);
        return String.fromCharCode(
            ((c0 & 0x0f) << 12) | ((c1 & 0x3f) <<  6) | (c2 & 0x3f)
        );
    }
};
    
var btou = function(bin){
    return bin.replace(re_bytes_nonascii, sub_bytes_nonascii);
};

if (!this['BasE91']) BasE91 = {
  encode:function(x){return base91_encode(btou(x))},
  decode:function(x){return utob(base91_decode(x))},
  btoa:base91_encode,
  atob:base91_decode,
  btou:btou,
  utob:utob
};

})();
